#pragma once

// Must be the first include
#include <glad/glad.h>

// Other includes
#include <GLFW/glfw3.h>

#include "Gedeng/String.h"

namespace Gedeng {

class RenderBackend {
  private:
    static inline GLFWwindow *window;

  public:
    static void initialize_window(unsigned int width, unsigned int height, String title);

    static bool is_window_created();

    static void set_depth_test_enabled(bool enabled);

    static bool does_window_want_to_close();

    static GLFWwindow *get_window();

    static void render();
};

} // namespace Gedeng